#include-once

; #INDEX# =======================================================================================================================
; Title .........: PasswordCoach
; AutoIt Version : 3.3.6.1++
; Language ......: English
; Description ...: Dialog box to prompt for new password and provide dynamic feedback on requirements.
; Author(s) .....: Jon Diercks <jon@diercks.net>
; ===============================================================================================================================

; compile: "c:\program files\AutoIt3\Aut2Exe\Aut2Exe.exe" /in PasswordCoach.au3 /out PasswordCoachDEMO.exe /icon checkmark.ico
; checkmark.ico must be present for icon to show up next to each requirement

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <ProgressConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Constants.au3>
#Include <WinAPI.au3>

$demo=True

if $demo Then
	;FileInstall icon?
	msgbox(0,"PasswordCoach DEMO", _
	  "This is a DEMO only, it does not actually change any passwords.")
	$np=""
	$op=""
	;if PasswordCoach($np,False,7) Then
	if PasswordCoach($np,$op) Then
		$msg="New password was accepted (but not actually changed)."
	;	msgbox(0,"PasswordCoach test", _
	;		"old pwd=" & $op & @CRLF & _
	;		"new pwd=" & $np )
	else
		$msg="Password form was cancelled."
	EndIf
	$msg &= @crlf & @crlf & _
		"Thank you for trying the demo. " & @CRLF & _
		"Please send any feedback to jon@diercks.net"
	msgbox(0,"PasswordCoach DEMO", $msg)
EndIf

Func PasswordCoach(byref $newPwdRtn,byref $oldPwdRtn,$minPwdLen=9)
	Opt("GUICloseOnESC", 1)
	#Region ### START Koda GUI section ### Form=Form1.kxf
	$PasswordCoach = GUICreate("New Password", 431, 208)
	$Label10 = GUICtrlCreateLabel("Please Choose a New Password", 88, 8, 260, 24)
	GUICtrlSetFont(-1, 12, 800, 0, "MS Sans Serif")
	$Label1 = GUICtrlCreateLabel("Old Password:", 48, 42, 72, 17)
	$Label2 = GUICtrlCreateLabel("New Password:", 42, 80, 78, 17)
	$Label3 = GUICtrlCreateLabel("New Password Again:", 12, 112, 108, 17)
	$Label9 = GUICtrlCreateLabel("Password Requirements", 264, 40, 139, 17)
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
	$Label5 = GUICtrlCreateLabel("letters (A-Z, a-z)", 296, 65, 78, 17)
	$Label6 = GUICtrlCreateLabel("numbers (0-9)", 296, 84, 68, 17)
	$Label7 = GUICtrlCreateLabel("symbols (%,$,#...)", 296, 104, 86, 17)
	$Label8 = GUICtrlCreateLabel("length: " & $minPwdLen & " or more", 296, 130, 100, 17)
	$Label4 = GUICtrlCreateLabel("Strengh Rating:", 42, 136, 78, 17)
	$hint = GUICtrlCreateLabel("Click [Help] for instructions", 10, 175, 200, 17)
	$oldPwd = GUICtrlCreateInput("", 128, 40, 121, 21, BitOR($ES_PASSWORD,$ES_AUTOHSCROLL))
	if $oldPwdRtn==False Then
		GUICtrlSetData(-1,String(10^$minPwdLen))
		setEnabled(-1,false)
	EndIf
	$newPwd = GUICtrlCreateInput("", 128, 78, 121, 21, BitOR($ES_PASSWORD,$ES_AUTOHSCROLL))
	$newPwd2 = GUICtrlCreateInput("", 128, 110, 121, 21, BitOR($ES_PASSWORD,$ES_AUTOHSCROLL))
	$rating = GUICtrlCreateProgress(128, 136, 118, 16)
	no_tab()
	$ckLetters = GUICtrlCreateIcon(@ScriptName, 0, 272, 65, 16, 16, BitOR($SS_NOTIFY,$WS_GROUP))
	setVisible(-1,false)
	no_tab()
	$ckSymbols = GUICtrlCreateIcon(@ScriptName, 0, 273, 104, 16, 16, BitOR($SS_NOTIFY,$WS_GROUP))
	setVisible(-1,false)
	no_tab()
	$ckNumbers = GUICtrlCreateIcon(@ScriptName, 0, 273, 84, 16, 16, BitOR($SS_NOTIFY,$WS_GROUP))
	setVisible(-1,false)
	no_tab()
	$ckLength = GUICtrlCreateIcon(@ScriptName, 0, 273, 130, 16, 16, BitOR($SS_NOTIFY,$WS_GROUP))
	setVisible(-1,false)
	no_tab()
	$btnOK = GUICtrlCreateButton("OK", 168, 168, 75, 25, 0)
	setEnabled(-1,false)
	GUICtrlSetState(-1,$GUI_DEFBUTTON)
	$btnCancel = GUICtrlCreateButton("Cancel", 256, 168, 75, 25, 0)
	$btnHelp = GUICtrlCreateButton("Help", 344, 168, 75, 25, 0)
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###

	$prevNewPwd=""
	$prevNewPwd2=""

	While 1
		$np=GUICtrlRead($newPwd)
		$np2=GUICtrlRead($newPwd2)
		if $np<>$prevNewPwd or $np2<>$prevNewPwd2 then 
			setVisible($ckLetters,StringRegExp($np,"[[:alpha:]]"))
			setVisible($ckNumbers,StringRegExp($np,"[[:digit:]]"))
			setVisible($ckSymbols,StringRegExp($np,"[[:punct:]]"))
			setVisible($ckLength,StringLen($np)>=$minPwdLen)
			
			;password rating: start with length, 4 points for each charcter
			$r=StringLen($np)*4
			;extra points for numbers and symbols
			$r+=StringLen(StringRegExpReplace($np,"[[:alpha:]]",""))*3
			;penalize for consecutive repeating or sequential characters
			$seq=1
			$rpt=1
			$prevc=0
			For $c in StringToASCIIArray($np)
				if $c == $prevc-1 or $c == $prevc+1 then
					$seq*=2
					$r-=$seq
				Else
					$seq=1
				EndIf
				if $c == $prevc then 
					$rpt*=2
					$r-=$rpt
				else
					$rpt=1
					$prevc=$c
				EndIf
			Next
			;fudge factor
			$r*=1.3
			if $r<0 then $r=0
			if $r>100 then $r=100
			GUICtrlSetData($rating, $r)
			if $r<25 then GUICtrlSetColor($rating,0xdd0000)
			if $r>=25 then GUICtrlSetColor($rating,0xffee00)
			if $r>=50 then GUICtrlSetColor($rating,0x00aa00)

			$hintText=""
			if $np <> $np2 then $hintText="passwords do not match"
			if $np <> $np2 and $np2 == StringLeft($np,StringLen($np2)) then $hintText="re-enter password to verify"
			if $r<50 then $hinttext="not complex enough"
			if not isVisible($ckLength) then $hintText="password must be longer"
			if not isVisible($ckSymbols) then $hintText="must include symbols"
			if not isVisible($ckNumbers) then $hintText="must include numbers"
			if not isVisible($ckLetters) then $hintText="must include letters"
			GUICtrlSetData($hint,$hintText)			
			setEnabled($btnOK, ($hintText==""))
			$prevNewPwd=$np
			$prevNewPwd2=$np2
		EndIf
		$msg=GUIGetMsg()
		if $msg=$btnHelp Then
				MsgBox(0,"PasswordCoach Help", _
					"Enter your old password if required, and your new password in the two spaces provided." & @CRLF & _
					"The password requirements will be checked off as you complete them." & @CRLF & _
					"To achieve a good strength rating, avoid repeated or sequential characters." & @CRLF & _
					"The OK button will be enabled when all requirements are met and both entered passwords match.")
		EndIf
		if $msg=$btnCancel or $msg=$GUI_EVENT_CLOSE then
			GUIDelete($PasswordCoach)
			return False
		EndIf
		if $msg=$btnOK then 
			$newPwdRtn=GUICtrlRead($newPwd)
			$oldPwdRtn=GUICtrlRead($oldPwd)
			GUIDelete($PasswordCoach)
			return True
		EndIf
	WEnd
EndFunc


Func isVisible($c)
	return BitAnd(GUICtrlGetState($c),$GUI_SHOW)
EndFunc

func setVisible($c,$set=True)
	if $set and not isVisible($c) Then GUICtrlSetState($c,$GUI_SHOW)
	if not $set and isVisible($c) Then GUICtrlSetState($c,$GUI_HIDE)
EndFunc
	
Func isEnabled($c)
	return BitAnd(GUICtrlGetState($c),$GUI_ENABLE)
EndFunc

func setEnabled($c,$set=True)
	if $set and not isEnabled($c) Then GUICtrlSetState($c,$GUI_ENABLE)
	if not $set and isEnabled($c) Then GUICtrlSetState($c,$GUI_DISABLE)
EndFunc

func no_tab() ;after control is created call this function to remove the tabstop if needed
    _WinAPI_SetWindowLong(GUICtrlGetHandle(-1), $GWL_STYLE, _
    BitAND(_WinAPI_GetWindowLong(GUICtrlGetHandle(-1), $GWL_STYLE), BitNOT($WS_TABSTOP)))
EndFunc

